<template>
  <div class="container">
    <div class="row">
      <div class="form-group col-md-4">
        <label class="control-label"> Otras partes </label>
        <p-radio class="d-inline-block" v-model="es_representacion" label="1">Si</p-radio>
        <p-radio class="d-inline-block" v-model="es_representacion" label="0">No</p-radio>
      </div>
    </div>
    <div v-if="es_representacion == '1'">
      <div v-if="add_item">
        <div class="row">
          <legend>Otras partes</legend>
        </div>
        <div class="row">
          <div class="form-group col-md-6">
            <label class="control-label"> Tipo de relación con el Titular: </label>
            <br>
            <div>
              <p-radio name="tipo_relacion" v-validate="otrasValidations.tipo_relacion" v-model="item_otras.tipo_relacion" :inline=true label="1">Copropietarios de bienes no comerciales</p-radio>
              <p-radio name="tipo_relacion" v-validate="otrasValidations.tipo_relacion" v-model="item_otras.tipo_relacion" :inline=true label="2">Garantes de préstamos recibidos</p-radio>
              <p-radio name="tipo_relacion" v-validate="otrasValidations.tipo_relacion" v-model="item_otras.tipo_relacion" :inline=true label="3">Otorgantes/depositarios de garantías</p-radio>
              <p-radio name="tipo_relacion" v-validate="otrasValidations.tipo_relacion" v-model="item_otras.tipo_relacion" :inline=true label="4">Otro</p-radio>
            </div>
            <small class="text-danger" v-show="tipo_relacion.invalid">
              {{ getError('tipo_relacion') }}
            </small>
          </div>
          <div class="form-group col-md-6" v-if=" item_otras.tipo_relacion == 4">
            <label class="control-label">Especificar tipo de relación</label>
            <input class="form-control" type="text" name="tipo_relacion_especificar" v-validate="otrasValidations.tipo_relacion_especificar" v-model="item_otras.tipo_relacion_especificar" placeholder="Especificar"><small class="text-danger" v-show="tipo_relacion_especificar.invalid">
              {{ getError('tipo_relacion_especificar') }}
            </small>
          </div>
          <div class="form-group col-md-12">
            <label class="control-label"> Nombre o denominación social de la parte relacionada: </label>
            <input class="form-control" type="text" name="nombre_denominacion_parte" v-validate="otrasValidations.nombre_denominacion_parte" v-model="item_otras.nombre_denominacion_parte" placeholder="Nombre o denominación social de la parte relacionada:" /><small class="text-danger" v-show="nombre_denominacion_parte.invalid">
              {{ getError('nombre_denominacion_parte') }}
            </small>
          </div>
          <div class="form-group col-md-6">
            <label class="control-label"> Fecha de inicio/Constitución de la relación: </label>
            <div class="form-group">
              <el-date-picker name="fecha_inicio_relacion" v-validate="otrasValidations.fecha_inicio_relacion" v-model="item_otras.fecha_inicio_relacion" type="date" placeholder="Seleccione fecha" value-format="dd-MM-yyyy" format="dd-MM-yyyy"></el-date-picker>
              <small class="text-danger" v-show="fecha_inicio_relacion.invalid">
                {{ getError('fecha_inicio_relacion') }}
              </small>
            </div>
          </div>
          <div class="form-group col-md-6">
            <label class="control-label"> Nacionalidades: </label>
            <el-select  clearable class="select-default" placeholder="Seleccione nacionalidad" filterable name="nacionalidad_id" v-validate="otrasValidations.nacionalidad_id" v-model="item_otras.nacionalidad_id">
              <el-option v-for="option in paisesnac" class="select-default" :value="option.id" :label="option.valor" :key="option.valor">
              </el-option>
            </el-select><small class="text-danger" v-show="nacionalidad_id.invalid">
              {{ getError('nacionalidad_id') }}
            </small>
          </div>
          <div class="form-group col-md-6">
            <label class="control-label"> CURP (si aplica): </label>
            <input class="form-control" type="text" name="curp" v-validate="otrasValidations.curp" v-model="item_otras.curp" placeholder="CURP" /><small class="text-danger" v-show="curp.invalid">
              {{ getError('curp') }}
            </small>
            <small class="text-danger" v-show="validaciones.curp"> El formato de la CURP no es válido, verifica la información </small>
          </div>
          <div class="form-group col-md-6">
            <label class="control-label"> RFC (si aplica): </label>
            <input class="form-control" type="text" name="rfc" v-validate="otrasValidations.rfc" v-model="item_otras.rfc" placeholder="RFC" /><small class="text-danger" v-show="rfc.invalid">
              {{ getError('rfc') }}
            </small>
            <small class="text-danger" v-show="validaciones.rfc"> El formato de la CURP no es válido, verifica la información </small>
          </div>
          <div class="col-md-4">
            <div class="form-group">
              <label class="control-label"> Fecha de nacimiento </label>
              <div class="form-group">
                <el-date-picker name="fecha_nacimiento" v-validate="otrasValidations.fecha_nacimiento" v-model="item_otras.fecha_nacimiento" type="date" placeholder="Seleccione fecha" value-format="dd-MM-yyyy" format="dd-MM-yyyy"></el-date-picker><small class="text-danger" v-show="fecha_nacimiento.invalid">
                  {{ getError('fecha_nacimiento') }}
                </small>
              </div>
            </div>
          </div>
          <div class="col-md-8">
            <div class="form-group">
              <label class="control-label"> Ocupación/Profesión </label>
              <input class="form-control" type="text" name="ocupacion" v-validate="otrasValidations.ocupacion" v-model="item_otras.ocupacion" placeholder="Ocupación / Profesión" /><small class="text-danger" v-show="ocupacion.invalid">
                {{ getError('ocupacion') }}
              </small>
            </div>
          </div>
        </div>
        <div class="row">
        </div>
        <div class="row">
          <div class="form-group col-md-12">
            <label class="control-label"> ¿Tiene la parte relacionada intereses en el mismo sector/industria al que pertenece el empleo oficial del Declarante? </label>
            <br>
            <div>
              <p-radio name="tiene_interes" v-validate="otrasValidations.tiene_interes" v-model="item_otras.tiene_interes" :inline=true label="1">SI</p-radio>
              <p-radio name="tiene_interes" v-validate="otrasValidations.tiene_interes" v-model="item_otras.tiene_interes" :inline=true label="2">NO</p-radio>
              <small class="text-danger" v-show="tiene_interes.invalid">
                {{ getError('tiene_interes') }}
              </small>
            </div>
          </div>
          <div class="form-group col-md-6">
            <label class="control-label"> Sector/Industria: </label>
            <el-select  clearable class="select-default" placeholder="Seleccione un sector-industria" filterable name="sector_industria_id" v-validate="otrasValidations.sector_industria_id" v-model="item_otras.sector_industria_id">
              <el-option v-for="option in sectores" class="select-default" :value="option.id" :label="option.valor" :key="option.label"></el-option>
            </el-select>
            <small class="text-danger" v-show="sector_industria_id.invalid">
              {{ getError('sector_industria_id') }}
            </small>
          </div>
          <div class="form-group col-md-6" v-if=" item_otras.sector_industria_id == 11">
            <label class="control-label">Especificar sector industria</label>
            <input class="form-control" type="text" name="especificar_sector_industria" v-validate="otrasValidations.especificar_sector_industria" v-model="item_otras.especificar_sector_industria" placeholder="Especificar"><small class="text-danger" v-show="especificar_sector_industria.invalid">
              {{ getError('especificar_sector_industria') }}
            </small>
          </div>
          <div class="col-md-6">
            <label class="control-label"> Observaciones/Comentarios: </label>
            <input class="form-control" type="text" name="observaciones" v-model="item_otras.observaciones" placeholder="Observaciones/Comentarios" />
          </div>
        </div>
        <div class="row justify-content-end m-3">
          <button class="btn btn-primary" @click.prevent="addItem()">
            <span v-if="edit_item == null">
              <i class="fa fa-plus"></i> Agregar </span>
            <span v-else>
              <i class="fa fa-save"></i> Guardar </span>
          </button>
          <button class="btn btn-primary ml-3" @click.prevent="cancelEdit()">
            <span>
              <i class="fa fa-times"></i> Cancelar </span>
          </button>
        </div>
        <div class="row">
          <hr class="col-md-12 bg-info">
        </div>
      </div>
      <div v-if="!add_item">
        <div class="row justify-content-end m-3">
          <button class="btn btn-primary" @click.prevent="showItem()">
            <span>
              <i class="fa fa-plus"></i> Agregar </span>
          </button>
        </div>
        <div class="row mt-3 mb-4">
          <div class="col-sm-12 col-md-12 col-lg-12">
            <b-table id="tbl_bienes" responsive hover :items="list_otras" :fields="fields_list" show-empty>
              <!-- :fields="fields_list" -->
              <template slot="acciones" slot-scope="row" class="actions">
                <b-button size="sm" @click.prevent="editItem(row)" class="edit mr-2" :disabled="edit_item != null"> Editar <i class="fas fa-pencil-alt ml-2"></i>
                </b-button>
                <b-button size="sm" @click.prevent="removeItem(row.index)" class="delete mr-2" :disabled="edit_item != null"> Eliminar <i class="fas fa-trash-alt ml-2"></i>
                </b-button>
              </template>
              <template slot="empty">
                <h5>No existen registros</h5>
              </template>
              <template slot="sector_industria_id" slot-scope="row">{{getSectores(row.item.sector_industria_id)}}</template>
              <template slot="nacionalidad_id" slot-scope="row">{{getNacionalidades(row.item.nacionalidad_id)}}</template>
            </b-table>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
  import {
    Tag,
    Select,
    DatePicker
  } from "element-ui";
  import Domicilio from "../Domicilio.vue";
  import {
    mapFields
  } from "vee-validate";
  export default {
    components: {
      [Tag.name]: Tag,
      [DatePicker.name]: DatePicker,
      Domicilio
    },
    computed: {
      ...mapFields(["tipo_relacion", "nombre_denominacion_parte", "fecha_inicio_relacion", "nacionalidad_id", "curp", "rfc", "fecha_nacimiento", "ocupacion", "tiene_interes", "sector_industria_id", "especificar_sector_industria", "tipo_relacion_especificar"])
    },
    watch: {
      list_otras: {
        handler: function() {
          if (this.list_otras) {
            if (this.list_otras.length == 0) {
              this.es_representacion = "0";
            } else {
              this.es_representacion = "1";
            }
          }
        },
        deep: true
      }
    },
    data() {
      return {
        validaciones: {
          curp: false,
          rfc: false
        },
        ip_id: 1,
        add_item: false,
        edit_item: null,
        es_representacion: "0",
        paisesnac: null,
        sectores: null,
        item_otras: {},
        list_otras: [],
        otrasValidations: {
          tipo_relacion: {
            required: true
          },
          tipo_relacion_especificar: {
            required: true
          },
          nombre_denominacion_parte: {
            required: true
          },
          fecha_inicio_relacion: {
            required: true
          },
          nacionalidad_id: {
            required: true
          },
          curp: {
            max: 18
          },
          fecha_nacimiento: {
            required: true
          },
          ocupacion: {
            required: true
          },
          tiene_interes: {
            required: true
          },
          sector_industria_id: {
            required: true
          },
          especificar_sector_industria: {
            required: true
          }
        },
        fields_list: [{
          key: "acciones",
          label: "Acciones",
          tdClass: "text-center"
        }, {
          key: "tipo_relacion",
          label: "Tipo Relación",
          tdClass: "text-left",
          formatter: "emptyFields"
        }, {
          key: "tipo_relacion_especificar",
          label: "Especificar",
          tdClass: "text-left",
          formatter: "emptyFields"
        }, {
          key: "nombre_denominacion_parte",
          label: "Nombre de la parte relacionada",
          tdClass: "text-left",
          formatter: "emptyFields"
        }, {
          key: "fecha_inicio_relacion",
          label: "Fecha inicio de la relación",
          tdClass: "text-left",
          formatter: "emptyFields"
        }, {
          key: "nacionalidad_id",
          label: "Nacionalidades",
          tdClass: "text-left",
          formatter: "emptyFields"
        }, {
          key: "curp",
          label: "CURP",
          tdClass: "text-right",
          formatter: "emptyFields"
        }, {
          key: "rfc",
          label: "RFC",
          tdClass: "text-right",
          formatter: "emptyFields"
        }, {
          key: "fecha_nacimiento",
          label: "Fecha Nacimiento",
          tdClass: "text-center",
          formatter: "emptyFields"
        }, {
          key: "ocupacion",
          label: "Ocupación/Profesión",
          tdClass: "text-right",
          formatter: "emptyFields"
        }, {
          key: "tiene_interes",
          label: "¿Tiene intereses?",
          tdClass: "text-right",
          formatter: "emptyFields"
        }, {
          key: "sector_industria_id",
          label: "Sector/Industria",
          tdClass: "text-right",
          formatter: "emptyFields"
        }, {
          key: "especificar_sector_industria",
          label: "Especificar",
          tdClass: "text-center",
          formatter: "emptyFields"
        }, {
          key: "observaciones",
          label: "Observaciones",
          tdClass: "text-left",
          formatter: "emptyFields"
        }],
        pickerOptions1: {
          shortcuts: [{
            text: "Today",
            onClick(picker) {
              picker.$emit("pick", new Date());
            }
          }, {
            text: "Yesterday",
            onClick(picker) {
              const date = new Date();
              date.setTime(date.getTime() - 3600 * 1000 * 24);
              picker.$emit("pick", date);
            }
          }, {
            text: "A week ago",
            onClick(picker) {
              const date = new Date();
              date.setTime(date.getTime() - 3600 * 1000 * 24 * 7);
              picker.$emit("pick", date);
            }
          }]
        },
        datePicker: "",
        model: {
          nombre: "",
          aPaterno: "",
          aMaterno: "",
          curp: "",
          tparticular: "",
          tcelular: "",
          rfc: "",
          nidentifica: "",
          cpersonal: "",
          pResidencia: "1",
          nacionalidades: {},
          email: "",
          estudios: "1"
        },
        tags: {
          dynamicTags: ["Mexicana"],
          inputVisible: false,
          inputValue: ""
        },
        modelValidations: {
          nombre: {
            min: 5
          },
          aPaterno: {
            min: 5
          },
          aMaterno: {
            min: 5
          },
          email: {
            required: true,
            email: true
          }
        }
      };
    },
    methods: {
      initItem() {
        this.n_domicilio = {
          pais: 150,
          entidadF: "",
          municipio: "",
          localidad: "",
          cp: "",
          colonia: "",
          vialidad: "",
          vialidad_nombre: "",
          ext: "",
          int: ""
        };
        this.item_bienes = {
          acciones: "",
          tipo_operacion_id: "",
          tipo_bien_id: "",
          titular_id: "",
          superficie_construccion: "",
          superficie_terreno: "",
          porcentaje_propiedad: 100,
          identificacion_bien_numero_escritura_publica: "",
          identificacion_bien_numero_registro_publico: "",
          identificacion_bien_folio_real: "",
          identificacion_bien_fecha_contrato: "",
          nombre_copropietario_nombres: "",
          nombre_copropietario_primer_apellido: "",
          nombre_copropietario_segundo_apellido: "",
          precio_adquisicion_valor: "",
          precio_adquisicion_moneda_id: 97,
          valor_catastral: "",
          fecha_adquisicion: "",
          forma_adquisicion_id: "",
          domicilio_bien_pais_id: "",
          domicilio_bien_entidad_federativa_id: "",
          domicilio_bien_municipio_id: "",
          domicilio_bien_localidad_id: "",
          domicilio_bien_colonia: "",
          domicilio_bien_cp: "",
          domicilio_bien_numext: "",
          domicilio_bien_numint: "",
          domicilio_bien_vialidad_nombre: "",
          domicilio_bien_vialidad_tipo: "",
          nombre_denominacion_quien_adquirio: "",
          rfc_quien_adquirio: "",
          curp_quien_adquirio: "",
          sector_industria_id: "",
          relacion_persona_adquirio_id: "",
          relacion_especificar: "",
          observaciones: ""
        };
      },
      showItem() {
        this.add_item = !this.add_item;
      },
      cancelEdit() {
        if (this.edit_item) {
          this.edit_item.item._rowVariant = "";
        }
        this.initItem();
        this.showItem();
        this.edit_item = null;
      },
      addItem() {
        this.$validator.validateAll().then(response => {
          if (response) {
            if (this.item_otras) {
              this.item_otras.ip_id = this.ip_id;
              this.loadButton(this.$refs.btnSave);
              this.$http.post("otras_partes", this.item_otras).then(response => {
                this.StepOk("Guardado");
                if (this.edit_item === undefined || this.edit_item === null) {
                  this.list_otras.push({
                    ...response.data.otra
                  });
                } else {
                  this.list_otras.splice(this.edit_item.index, 1, this.item_otras);
                  this.edit_item.item._rowVariant = "";
                }
                this.showItem();
                this.initItem();
                this.edit_item = null;
              }, error => {
                this.StepError(error);
                //this.change =  true;
              });
            }
          } else {
            this.StepW("Hay campos sin completar");
          }
        });
        //console.log(this.item_bienes);
      },
      editItem(indice) {
        this.showItem();
        this.edit_item = indice;
        this.item_otras = {
          ...this.list_otras[this.edit_item.index]
        };
        //this.editDomicilio();
        this.edit_item.item._rowVariant = "danger";
        $(".main-panel").animate({
          scrollTop: 100
        }, 500, "swing");
      },
      removeItem(indice) {
        if (this.list_otras[indice].id !== null) {
          let item = this.list_otras[indice];
          this.list_otras.splice(indice, 1);
          this.Ask("Desea borrar este registro", () => {
            this.$http.delete("otras_partes/" + item.id).then(response => {
              /* eventBus.$emit("TramiteDelete", item); */
              this.list_otras.splice(indice, 1);
            }, error => {
              this.Err(error);
            });
          });
        } else {
          this.Ask("Desea borrar este registro", () => {
            this.list_otras.splice(indice, 1);
          });
        }
      },
      getNacionalidades(index) {
        var resp = " ";
        if (this.paisesnac) {
          this.paisesnac.forEach(function(item) {
            if (item.id == index) {
              resp = item.valor;
              return resp;
            }
          });
        }
        return resp;
      },
      getSectores(index) {
        var resp = " ";
        if (this.sectores) {
          this.sectores.forEach(function(item) {
            if (item.id == index) {
              resp = item.valor;
              return resp;
            }
          });
        }
        return resp;
      },
      getError(fieldName) {
        return this.errors.first(fieldName);
      },
      validate() {
        if (this.add_item) {
          this.validaciones = {
            rfc: false,
            curp: false
          };
          if (!this.curpValida(this.item_otras.curp)) {
            this.validaciones.curp = true;
            return false;
          }
          if (!this.rfcValido(this.item_otras.rfc)) {
            this.validaciones.rfc = true;
            return false;
          }
        }
        return this.$validator.validateAll();
      },
      handleClose(tag) {
        this.tags.dynamicTags.splice(this.tags.dynamicTags.indexOf(tag), 1);
      },
      showInput() {
        this.tags.inputVisible = true;
        this.$nextTick(() => {
          this.$refs.saveTagInput.$refs.input.focus();
        });
      },
      handleInputConfirm() {
        let inputValue = this.tags.inputValue;
        if (inputValue) {
          this.tags.dynamicTags.push(inputValue);
        }
        this.tags.inputVisible = false;
        this.tags.inputValue = "";
      }
    },
    created() {
      this.initItem();
      //this.getLocalidades(97250);
      this.$http.get("otras_partes/" + this.ip_id).then(response => {
        this.list_otras = response.data.otras;
        //this.setLocalidades();
      }, error => {
        this.Err(error);
      });
      this.$http.get("paises").then(response => {
        this.paisesnac = response.data.pais;
      }, error => {
        this.Err(error);
      });
      this.$http.get("cat_sector_industria").then(response => {
        this.sectores = response.data.sectores;
      }, error => {
        this.Err(error);
      });
    }
  };

</script>
<style>
</style>
